unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Grids, ComCtrls, Gauges;

type
  TDebuggerForm = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Splitter1: TSplitter;
    Splitter2: TSplitter;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    StringGrid1: TStringGrid;
    CheckBoxMem: TCheckBox;
    Panel4: TPanel;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Panel3: TPanel;
    Label15: TLabel;
    Label21: TLabel;
    Edit4: TEdit;
    Button4: TButton;
    Edit6: TEdit;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    PageControl2: TPageControl;
    TabSheet4: TTabSheet;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Edit1: TEdit;
    ComboBoxPoisk: TComboBox;
    Button5: TButton;
    ListBox1: TListBox;
    TabSheet5: TTabSheet;
    Label19: TLabel;
    Label20: TLabel;
    Button2: TButton;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    Edit5: TEdit;
    TabSheet6: TTabSheet;
    StatusBar1: TStatusBar;
    PageControl3: TPageControl;
    TabSheet7: TTabSheet;
    TabSheet8: TTabSheet;
    CheckBox16_10: TCheckBox;
    Edit3: TEdit;
    Label14: TLabel;
    Edit2: TEdit;
    Button3: TButton;
    Label13: TLabel;
    ListBox2: TListBox;
    Button1: TButton;
    Edit7: TEdit;
    Label22: TLabel;
    Label23: TLabel;
    StringGridAss: TStringGrid;
    ListBox3: TListBox;
    procedure FormCreate(Sender: TObject);
    procedure StringGrid1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure StringGrid1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure StringGrid1KeyPress(Sender: TObject; var Key: Char);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    function  HexToInt(CH : string): integer;
    procedure Edit2KeyPress(Sender: TObject; var Key: Char);
    procedure Edit3KeyPress(Sender: TObject; var Key: Char);
    procedure Edit4KeyPress(Sender: TObject; var Key: Char);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Button5Click(Sender: TObject);
    procedure ComboBoxPoiskKeyPress(Sender: TObject; var Key: Char);
    procedure ListBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button4Click(Sender: TObject);
    procedure Edit6KeyPress(Sender: TObject; var Key: Char);
    procedure AssFromTo(AssFrom, AssTo: integer);
    procedure ListBox2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Edit7KeyPress(Sender: TObject; var Key: Char);
    procedure Button1Click(Sender: TObject);
    procedure StringGridAssDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure ListBox3MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DebuggerForm: TDebuggerForm;
  memory_old: array [0..65535] of byte;
  GaugeMain: TGauge;

  const
  hexdigit: set of Char = ['0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F','a','b','c','d','e','f',#13,#8];

  type TGridCracker = class(TStringGrid);


implementation


uses Unit1;

{$R *.dfm}
procedure TDebuggerForm.Button1Click(Sender: TObject);
var
i: integer;
a: word;
b: byte;
begin
a:=0;
GaugeMain.MinValue:=0;
GaugeMain.MaxValue:=$FFFF;
GaugeMain.Progress:=0;
ListBox2.Items.Clear;
b:=strtoint(Edit7.Text);
     for I := 0 to $ffff do
         begin
           if memory[i]=b then
                 begin
                   inc(a);
                   ListBox2.Items.add(inttostr(i));
                   GaugeMain.Progress:=i;
                 end;
         end;
     if a<>0 then
     Label23.Caption:=':'+inttostr(a)
     else
     ShowMessage('   !!!');
end;

procedure TDebuggerForm.Button2Click(Sender: TObject);

var
  I: Integer;
begin
for I := 0 to $ffff do
    begin
    if memory_old[i]-1 <>0 then
       if unit1.memory[i]=memory_old[i]-1 then
         ListBox3.Items.add(inttostr(i));
    end;

{for I := 0 to Memo1.Lines.Count-1 do
    begin
      if memory[strtoint(memo1.Lines.Strings[i])]=strtoint(edit1.text) then
           memo2.lines.add(memo1.Lines.Strings[i]);
    end; }
end;

procedure TDebuggerForm.Button3Click(Sender: TObject);
begin
if CheckBox16_10.Checked then
unit1.memory[hextoint(edit2.Text)]:=hextoint(edit3.text)
else
unit1.memory[strtoint(edit2.Text)]:=strtoint(edit3.text);
end;


procedure TDebuggerForm.Button4Click(Sender: TObject);
begin
AssFromTo(strtoint(edit4.text),strtoint(edit6.Text));
end;

procedure TDebuggerForm.AssFromTo(AssFrom, AssTo: integer);
var
i,j,kommand,a: integer;
begin
  for I := 0 to StringGrid1.RowCount - 1 do     //   
     StringGridAss.Rows[I].Clear();

a:=0;
StringGridAss.ColWidths[0]:=60;
StringGridAss.ColWidths[1]:=150;
StringGridAss.ColWidths[2]:=60;
StringGridAss.RowCount:=1;

GaugeMain.MinValue:=0;
GaugeMain.MaxValue:=AssTo-AssFrom;
GaugeMain.Progress:=0;
i:=AssFrom;
j:=AssTo+1;
     while i<j do
      begin
        case memory[i] of
           $00: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='00 '; StringGridAss.Cells[2,a]:='NOP'; end;
           $F3: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='F3 '; StringGridAss.Cells[2,a]:='DI'; end;
           $FB: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='FB '; StringGridAss.Cells[2,a]:='EI'; end;
           $01: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='01 '+inttohex(memory[i+1],2)+' '+inttohex(memory[i+2],2); StringGridAss.Cells[2,a]:= 'LXI B,'; StringGridAss.Cells[3,a]:=inttohex(memory[i+2],2)+inttohex(memory[i+1],2);      i:=i+2; end;
           $02: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='02 '; StringGridAss.Cells[2,a]:='STAX B'; end;
           $03: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='03 '; StringGridAss.Cells[2,a]:='INX B'; end;
           $04: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='04 '; StringGridAss.Cells[2,a]:='INR B'; end;
           $05: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='05 '; StringGridAss.Cells[2,a]:='DCR B'; end;
           $06: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='06 '+inttohex(memory[i+1],2); StringGridAss.Cells[2,a]:= 'MVI B ,'+inttohex(memory[i+1],2);      i:=i+1;   end;
           $07: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='07 '; StringGridAss.Cells[2,a]:='RLC'; end;
           $08: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='08 '; StringGridAss.Cells[2,a]:='_nop_'; end;
           $10: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='10 '; StringGridAss.Cells[2,a]:='_nop_'; end;
           $18: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='18 '; StringGridAss.Cells[2,a]:='_nop_'; end;
           $20: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='20 '; StringGridAss.Cells[2,a]:='_nop_'; end;
           $28: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='28 '; StringGridAss.Cells[2,a]:='_nop_'; end;
           $30: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='30 '; StringGridAss.Cells[2,a]:='_nop_'; end;
           $38: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='38 '; StringGridAss.Cells[2,a]:='_nop_'; end;
           $09: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='09 '; StringGridAss.Cells[2,a]:='DAD B'; end;
           $0A: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='0A '; StringGridAss.Cells[2,a]:='LDAX B'; end;
           $0B: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='0B '; StringGridAss.Cells[2,a]:='DCX B'; end;
           $0C: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='0C '; StringGridAss.Cells[2,a]:='INR C'; end;
           $0D: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='0D '; StringGridAss.Cells[2,a]:='DCR C'; end;
           $0E: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='0E '+inttohex(memory[i+1],2); StringGridAss.Cells[2,a]:= 'MVI C ,'+inttohex(memory[i+1],2);      i:=i+1;   end;
           $0F: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='0F '; StringGridAss.Cells[2,a]:='RRC'; end;
           $11: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='11 '+inttohex(memory[i+1],2)+' '+inttohex(memory[i+2],2); StringGridAss.Cells[2,a]:= 'LXI D,'; StringGridAss.Cells[3,a]:=inttohex(memory[i+2],2)+inttohex(memory[i+1],2);      i:=i+2;  end;
           $12: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='12 '; StringGridAss.Cells[2,a]:='STAX D'; end;
           $13: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='13 '; StringGridAss.Cells[2,a]:='INX D'; end;
           $14: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='14 '; StringGridAss.Cells[2,a]:='INR D'; end;
           $15: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='15 '; StringGridAss.Cells[2,a]:='DCR D'; end;
           $16: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='16 '+inttohex(memory[i+1],2); StringGridAss.Cells[2,a]:= 'MVI D ,'+inttohex(memory[i+1],2);      i:=i+1;   end;
           $17: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='17 '; StringGridAss.Cells[2,a]:='RAL'; end;
           $19: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='19 '; StringGridAss.Cells[2,a]:='DAD D'; end;
           $1A: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='1A '; StringGridAss.Cells[2,a]:='LDAX D'; end;
           $1B: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='1B '; StringGridAss.Cells[2,a]:='DCX D'; end;
           $1C: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='1C '; StringGridAss.Cells[2,a]:='INR E'; end;
           $1D: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='1D '; StringGridAss.Cells[2,a]:='DCR E'; end;
           $1E: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='1E '+inttohex(memory[i+1],2); StringGridAss.Cells[2,a]:= 'MVI E ,'+inttohex(memory[i+1],2);      i:=i+1;   end;
           $1F: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='1F '; StringGridAss.Cells[2,a]:='RAR'; end;
           $21: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='21 '+inttohex(memory[i+1],2)+' '+inttohex(memory[i+2],2); StringGridAss.Cells[2,a]:= 'LXI H,'; StringGridAss.Cells[3,a]:=inttohex(memory[i+2],2)+inttohex(memory[i+1],2);i:=i+2;  end;
           $22: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='22 '+inttohex(memory[i+1],2)+' '+inttohex(memory[i+2],2); StringGridAss.Cells[2,a]:= 'SHLD '; StringGridAss.Cells[3,a]:=inttohex(memory[i+2],2)+inttohex(memory[i+1],2);      i:=i+2;  end;
           $23: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='23 '; StringGridAss.Cells[2,a]:='INX H'; end;
           $24: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='24 '; StringGridAss.Cells[2,a]:='INR H'; end;
           $25: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='25 '; StringGridAss.Cells[2,a]:='DCR H'; end;
           $26: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='26 '+inttohex(memory[i+1],2); StringGridAss.Cells[2,a]:= 'MVI H ,'+inttohex(memory[i+1],2);      i:=i+1;   end;
           $27: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='27 '; StringGridAss.Cells[2,a]:='DAA'; end;
           $29: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='29 '; StringGridAss.Cells[2,a]:='DAD H'; end;
           $2A: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='2A '+inttohex(memory[i+1],2)+' '+inttohex(memory[i+2],2); StringGridAss.Cells[2,a]:= 'LHLD '; StringGridAss.Cells[3,a]:=inttohex(memory[i+2],2)+inttohex(memory[i+1],2);      i:=i+2;  end;
           $2B: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='2B '; StringGridAss.Cells[2,a]:='DCX H'; end;
           $2C: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='2C '; StringGridAss.Cells[2,a]:='INR L'; end;
           $2D: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='2D '; StringGridAss.Cells[2,a]:='DCR L'; end;
           $2E: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='2E '+inttohex(memory[i+1],2); StringGridAss.Cells[2,a]:= 'MVI L ,'+inttohex(memory[i+1],2);      i:=i+1;   end;
           $2F: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='2F '; StringGridAss.Cells[2,a]:='CMA'; end;
           $31: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='31 '+inttohex(memory[i+1],2)+' '+inttohex(memory[i+2],2); StringGridAss.Cells[2,a]:= 'LXI SP,'; StringGridAss.Cells[3,a]:=inttohex(memory[i+2],2)+inttohex(memory[i+1],2);      i:=i+2;  end;
           $32: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='32 '+inttohex(memory[i+1],2)+' '+inttohex(memory[i+2],2); StringGridAss.Cells[2,a]:= 'STA '; StringGridAss.Cells[3,a]:=inttohex(memory[i+2],2)+inttohex(memory[i+1],2);      i:=i+2;  end;
           $33: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='33 '; StringGridAss.Cells[2,a]:='INX SP'; end;
           $34: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='34 '; StringGridAss.Cells[2,a]:='INR M'; end;
           $35: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='35 '; StringGridAss.Cells[2,a]:='DCR M'; end;
           $36: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='36 '+inttohex(memory[i+1],2); StringGridAss.Cells[2,a]:= 'MVI M ,'+inttohex(memory[i+1],2);      i:=i+1;   end;
           $37: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='37 '; StringGridAss.Cells[2,a]:='STC'; end;
           $39: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='39 '; StringGridAss.Cells[2,a]:='DAD SP'; end;
           $3A: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='3A '+inttohex(memory[i+1],2)+' '+inttohex(memory[i+2],2); StringGridAss.Cells[2,a]:= 'LDA '; StringGridAss.Cells[3,a]:=inttohex(memory[i+2],2)+inttohex(memory[i+1],2);      i:=i+2;  end;
           $3B: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='3B '; StringGridAss.Cells[2,a]:='DCX SP'; end;
           $3C: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='3C '; StringGridAss.Cells[2,a]:='INR A'; end;
           $3D: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='3D '; StringGridAss.Cells[2,a]:='DCR A'; end;
           $3E: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='3E '+inttohex(memory[i+1],2); StringGridAss.Cells[2,a]:= 'MVI A ,'+inttohex(memory[i+1],2);      i:=i+1;   end;
           $3F: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='3F '; StringGridAss.Cells[2,a]:='CMC'; end;
           $40: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='40 '; StringGridAss.Cells[2,a]:='MOV B,B'; end;
           $49: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='49 '; StringGridAss.Cells[2,a]:='MOV C,C'; end;
           $52: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='52 '; StringGridAss.Cells[2,a]:='MOV D,D'; end;
           $5B: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='5B '; StringGridAss.Cells[2,a]:='MOV E,E'; end;
           $64: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='64 '; StringGridAss.Cells[2,a]:='MOV H,H'; end;
           $6D: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='6D '; StringGridAss.Cells[2,a]:='MOV L,L'; end;
           $7F: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='7F '; StringGridAss.Cells[2,a]:='MOV A,A'; end;
           $41: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='41 '; StringGridAss.Cells[2,a]:='MOV B,C'; end;
           $42: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='42 '; StringGridAss.Cells[2,a]:='MOV B,D'; end;
           $43: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='43 '; StringGridAss.Cells[2,a]:='MOV B,E'; end;
           $44: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='44 '; StringGridAss.Cells[2,a]:='MOV B,H'; end;
           $45: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='45 '; StringGridAss.Cells[2,a]:='MOV B,L'; end;
           $46: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='46 '; StringGridAss.Cells[2,a]:='MOV B,M'; end;
           $47: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='47 '; StringGridAss.Cells[2,a]:='MOV B,A'; end;
           $48: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='48 '; StringGridAss.Cells[2,a]:='MOV C,B'; end;
           $4A: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='4A '; StringGridAss.Cells[2,a]:='MOV C,D'; end;
           $4B: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='4B '; StringGridAss.Cells[2,a]:='MOV C,E'; end;
           $4C: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='4C '; StringGridAss.Cells[2,a]:='MOV C,H'; end;
           $4D: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='4D '; StringGridAss.Cells[2,a]:='MOV C,L'; end;
           $4E: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='4E '; StringGridAss.Cells[2,a]:='MOV C,M'; end;
           $4F: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='4F '; StringGridAss.Cells[2,a]:='MOV C,A'; end;
           $50: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='50 '; StringGridAss.Cells[2,a]:='MOV D,B'; end;
           $51: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='51 '; StringGridAss.Cells[2,a]:='MOV D,C'; end;
           $53: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='53 '; StringGridAss.Cells[2,a]:='MOV D,E'; end;
           $54: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='54 '; StringGridAss.Cells[2,a]:='MOV D,H'; end;
           $55: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='55 '; StringGridAss.Cells[2,a]:='MOV D,L'; end;
           $56: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='56 '; StringGridAss.Cells[2,a]:='MOV D,M'; end;
           $57: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='57 '; StringGridAss.Cells[2,a]:='MOV D,A'; end;
           $58: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='58 '; StringGridAss.Cells[2,a]:='MOV E,B'; end;
           $59: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='59 '; StringGridAss.Cells[2,a]:='MOV E,C'; end;
           $5A: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='5A '; StringGridAss.Cells[2,a]:='MOV E,D'; end;
           $5C: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='5C '; StringGridAss.Cells[2,a]:='MOV E,H'; end;
           $5D: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='5D '; StringGridAss.Cells[2,a]:='MOV E,L'; end;
           $5E: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='5E '; StringGridAss.Cells[2,a]:='MOV E,M'; end;
           $5F: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='5F '; StringGridAss.Cells[2,a]:='MOV E,A'; end;
           $60: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='60 '; StringGridAss.Cells[2,a]:='MOV H,B'; end;
           $61: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='61 '; StringGridAss.Cells[2,a]:='MOV H,C'; end;
           $62: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='62 '; StringGridAss.Cells[2,a]:='MOV H,D'; end;
           $63: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='63 '; StringGridAss.Cells[2,a]:='MOV H,E'; end;
           $65: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='65 '; StringGridAss.Cells[2,a]:='MOV H,L'; end;
           $66: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='66 '; StringGridAss.Cells[2,a]:='MOV H,M'; end;
           $67: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='67 '; StringGridAss.Cells[2,a]:='MOV H,A'; end;
           $68: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='68 '; StringGridAss.Cells[2,a]:='MOV L,B'; end;
           $69: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='69 '; StringGridAss.Cells[2,a]:='MOV L,C'; end;
           $6A: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='6A '; StringGridAss.Cells[2,a]:='MOV L,D'; end;
           $6B: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='6B '; StringGridAss.Cells[2,a]:='MOV L,E'; end;
           $6C: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='6C '; StringGridAss.Cells[2,a]:='MOV L,H'; end;
           $6E: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='6E '; StringGridAss.Cells[2,a]:='MOV L,M'; end;
           $6F: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='6F '; StringGridAss.Cells[2,a]:='MOV L,A'; end;
           $70: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='70 '; StringGridAss.Cells[2,a]:='MOV M,B'; end;
           $71: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='71 '; StringGridAss.Cells[2,a]:='MOV M,C'; end;
           $72: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='72 '; StringGridAss.Cells[2,a]:='MOV M,D'; end;
           $73: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='73 '; StringGridAss.Cells[2,a]:='MOV M,E'; end;
           $74: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='74 '; StringGridAss.Cells[2,a]:='MOV M,H'; end;
           $75: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='75 '; StringGridAss.Cells[2,a]:='MOV M,L'; end;
           $76: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='76 '; StringGridAss.Cells[2,a]:='HLT'; end;
           $77: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='77 '; StringGridAss.Cells[2,a]:='MOV M,A'; end;
           $78: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='78 '; StringGridAss.Cells[2,a]:='MOV A,B'; end;
           $79: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='79 '; StringGridAss.Cells[2,a]:='MOV A,C'; end;
           $7A: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='7A '; StringGridAss.Cells[2,a]:='MOV A,D'; end;
           $7B: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='7B '; StringGridAss.Cells[2,a]:='MOV A,E'; end;
           $7C: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='7C '; StringGridAss.Cells[2,a]:='MOV A,H'; end;
           $7D: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='7D '; StringGridAss.Cells[2,a]:='MOV A,L'; end;
           $7E: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='7E '; StringGridAss.Cells[2,a]:='MOV A,M'; end;
           $80: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='80 '; StringGridAss.Cells[2,a]:='ADD B'; end;
           $81: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='81 '; StringGridAss.Cells[2,a]:='ADD C'; end;
           $82: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='82 '; StringGridAss.Cells[2,a]:='ADD D'; end;
           $83: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='83 '; StringGridAss.Cells[2,a]:='ADD E'; end;
           $84: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='84 '; StringGridAss.Cells[2,a]:='ADD H'; end;
           $85: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='85 '; StringGridAss.Cells[2,a]:='ADD L'; end;
           $86: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='86 '; StringGridAss.Cells[2,a]:='ADD M'; end;
           $87: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='87 '; StringGridAss.Cells[2,a]:='ADD A'; end;
           $88: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='88 '; StringGridAss.Cells[2,a]:='ADC B'; end;
           $89: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='89 '; StringGridAss.Cells[2,a]:='ADC C'; end;
           $8A: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='8A '; StringGridAss.Cells[2,a]:='ADC D'; end;
           $8B: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='8B '; StringGridAss.Cells[2,a]:='ADC E'; end;
           $8C: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='8C '; StringGridAss.Cells[2,a]:='ADC H'; end;
           $8D: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='8D '; StringGridAss.Cells[2,a]:='ADC L'; end;
           $8E: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='8E '; StringGridAss.Cells[2,a]:='ADC M'; end;
           $8F: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='8F '; StringGridAss.Cells[2,a]:='ADC A'; end;
           $90: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='90 '; StringGridAss.Cells[2,a]:='SUB B'; end;
           $91: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='91 '; StringGridAss.Cells[2,a]:='SUB C'; end;
           $92: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='92 '; StringGridAss.Cells[2,a]:='SUB D'; end;
           $93: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='93 '; StringGridAss.Cells[2,a]:='SUB E'; end;
           $94: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='94 '; StringGridAss.Cells[2,a]:='SUB H'; end;
           $95: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='95 '; StringGridAss.Cells[2,a]:='SUB L'; end;
           $96: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='96 '; StringGridAss.Cells[2,a]:='SUB M'; end;
           $97: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='97 '; StringGridAss.Cells[2,a]:='SUB A'; end;
           $98: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='98 '; StringGridAss.Cells[2,a]:='SBB B'; end;
           $99: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='99 '; StringGridAss.Cells[2,a]:='SBB C'; end;
           $9A: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='9A '; StringGridAss.Cells[2,a]:='SBB D'; end;
           $9B: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='9B '; StringGridAss.Cells[2,a]:='SBB E'; end;
           $9C: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='9C '; StringGridAss.Cells[2,a]:='SBB H'; end;
           $9D: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='9D '; StringGridAss.Cells[2,a]:='SBB L'; end;
           $9E: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='9E '; StringGridAss.Cells[2,a]:='SBB M'; end;
           $9F: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='9F '; StringGridAss.Cells[2,a]:='SBB A'; end;
           $A0: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='A0 '; StringGridAss.Cells[2,a]:='ANA B'; end;
           $A1: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='A1 '; StringGridAss.Cells[2,a]:='ANA C'; end;
           $A2: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='A2 '; StringGridAss.Cells[2,a]:='ANA D'; end;
           $A3: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='A3 '; StringGridAss.Cells[2,a]:='ANA E'; end;
           $A4: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='A4 '; StringGridAss.Cells[2,a]:='ANA H'; end;
           $A5: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='A5 '; StringGridAss.Cells[2,a]:='ANA L'; end;
           $A6: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='A6 '; StringGridAss.Cells[2,a]:='ANA M'; end;
           $A7: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='A7 '; StringGridAss.Cells[2,a]:='ANA A'; end;
           $A8: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='A8 '; StringGridAss.Cells[2,a]:='XRA B'; end;
           $A9: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='A9 '; StringGridAss.Cells[2,a]:='XRA C'; end;
           $AA: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='AA '; StringGridAss.Cells[2,a]:='XRA D'; end;
           $AB: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='AB '; StringGridAss.Cells[2,a]:='XRA E'; end;
           $AC: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='AC '; StringGridAss.Cells[2,a]:='XRA H'; end;
           $AD: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='AD '; StringGridAss.Cells[2,a]:='XRA L'; end;
           $AE: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='AE '; StringGridAss.Cells[2,a]:='XRA M'; end;
           $AF: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='AF '; StringGridAss.Cells[2,a]:='XRA A'; end;
           $B0: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='B0 '; StringGridAss.Cells[2,a]:='ORA B'; end;
           $B1: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='B1 '; StringGridAss.Cells[2,a]:='ORA C'; end;
           $B2: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='B2 '; StringGridAss.Cells[2,a]:='ORA D'; end;
           $B3: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='B3 '; StringGridAss.Cells[2,a]:='ORA E'; end;
           $B4: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='B4 '; StringGridAss.Cells[2,a]:='ORA H'; end;
           $B5: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='B5 '; StringGridAss.Cells[2,a]:='ORA L'; end;
           $B6: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='B6 '; StringGridAss.Cells[2,a]:='ORA M'; end;
           $B7: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='B7 '; StringGridAss.Cells[2,a]:='ORA A'; end;
           $B8: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='B8 '; StringGridAss.Cells[2,a]:='CMP B'; end;
           $B9: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='B9 '; StringGridAss.Cells[2,a]:='CMP C'; end;
           $BA: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='BA '; StringGridAss.Cells[2,a]:='CMP D'; end;
           $BB: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='BB '; StringGridAss.Cells[2,a]:='CMP E'; end;
           $BC: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='BC '; StringGridAss.Cells[2,a]:='CMP H'; end;
           $BD: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='BD '; StringGridAss.Cells[2,a]:='CMP L'; end;
           $BE: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='BE '; StringGridAss.Cells[2,a]:='CMP M'; end;
           $BF: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='BF '; StringGridAss.Cells[2,a]:='CMP A'; end;
           $C0: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='C0 '; StringGridAss.Cells[2,a]:='RNZ'; end;
           $C1: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='C1 '; StringGridAss.Cells[2,a]:='POP B'; end;
           $C2: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='C2 '+inttohex(memory[i+1],2)+' '+inttohex(memory[i+2],2); StringGridAss.Cells[2,a]:= 'JNZ '; StringGridAss.Cells[3,a]:=inttohex(memory[i+2],2)+inttohex(memory[i+1],2);      i:=i+2;  end;
           $C3: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='C3 '+inttohex(memory[i+1],2)+' '+inttohex(memory[i+2],2); StringGridAss.Cells[2,a]:= 'JMP '; StringGridAss.Cells[3,a]:=inttohex(memory[i+2],2)+inttohex(memory[i+1],2);      i:=i+2;  end;
           $C4: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='C4 '+inttohex(memory[i+1],2)+' '+inttohex(memory[i+2],2); StringGridAss.Cells[2,a]:= 'CNZ '; StringGridAss.Cells[3,a]:=inttohex(memory[i+2],2)+inttohex(memory[i+1],2);      i:=i+2;  end;
           $C5: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='C5 '; StringGridAss.Cells[2,a]:='PUSH B'; end;
           $C6: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='C6 '+inttohex(memory[i+1],2); StringGridAss.Cells[2,a]:= 'ADI ,'+inttohex(memory[i+1],2);      i:=i+1;   end;
           $C7: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='C7 '; StringGridAss.Cells[2,a]:='RST 0'; end;
           $C8: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='C8 '; StringGridAss.Cells[2,a]:='RZ'; end;
           $C9: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='C9 '; StringGridAss.Cells[2,a]:='RET'; end;
           $CA: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='CA '+inttohex(memory[i+1],2)+' '+inttohex(memory[i+2],2); StringGridAss.Cells[2,a]:= 'JZ '; StringGridAss.Cells[3,a]:=inttohex(memory[i+2],2)+inttohex(memory[i+1],2);      i:=i+2;  end;
           $CB: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='CB '+inttohex(memory[i+1],2)+' '+inttohex(memory[i+2],2); StringGridAss.Cells[2,a]:= '_jmp_ '; StringGridAss.Cells[3,a]:=inttohex(memory[i+2],2)+inttohex(memory[i+1],2);      i:=i+2;  end;
           $CC: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='CC '+inttohex(memory[i+1],2)+' '+inttohex(memory[i+2],2); StringGridAss.Cells[2,a]:= 'CZ '; StringGridAss.Cells[3,a]:=inttohex(memory[i+2],2)+inttohex(memory[i+1],2);      i:=i+2;  end;
           $CD: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='CD '+inttohex(memory[i+1],2)+' '+inttohex(memory[i+2],2); StringGridAss.Cells[2,a]:= 'CALL '; StringGridAss.Cells[3,a]:=inttohex(memory[i+2],2)+inttohex(memory[i+1],2);      i:=i+2;  end;
           $CE: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='CE '+inttohex(memory[i+1],2); StringGridAss.Cells[2,a]:= 'ACI ,'+inttohex(memory[i+1],2);      i:=i+1;   end;
           $CF: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='CF '; StringGridAss.Cells[2,a]:='RST 1'; end;
           $D0: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='D0 '; StringGridAss.Cells[2,a]:='RNC'; end;
           $D1: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='D1 '; StringGridAss.Cells[2,a]:='POP D'; end;
           $D2: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='D2 '+inttohex(memory[i+1],2)+' '+inttohex(memory[i+2],2); StringGridAss.Cells[2,a]:= 'JNC '; StringGridAss.Cells[3,a]:=inttohex(memory[i+2],2)+inttohex(memory[i+1],2);      i:=i+2;  end;
           $D3: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='D3 '+inttohex(memory[i+1],2); StringGridAss.Cells[2,a]:= 'OUT port';      end;
           $D4: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='D4 '+inttohex(memory[i+1],2)+' '+inttohex(memory[i+2],2); StringGridAss.Cells[2,a]:= 'CNC '; StringGridAss.Cells[3,a]:=inttohex(memory[i+2],2)+inttohex(memory[i+1],2);      i:=i+2;  end;
           $D5: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='D5 '; StringGridAss.Cells[2,a]:='PUSH D'; end;
           $D6: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='D6 '+inttohex(memory[i+1],2); StringGridAss.Cells[2,a]:= 'SUI ,'+inttohex(memory[i+1],2);      i:=i+1;   end;
           $D7: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='D7 '; StringGridAss.Cells[2,a]:='RST 2'; end;
           $D8: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='D8 '; StringGridAss.Cells[2,a]:='RC'; end;
           $D9: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='D9 '; StringGridAss.Cells[2,a]:='_ret_'; end;
           $DA: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='DA '+inttohex(memory[i+1],2)+' '+inttohex(memory[i+2],2); StringGridAss.Cells[2,a]:= 'JC '; StringGridAss.Cells[3,a]:=inttohex(memory[i+2],2)+inttohex(memory[i+1],2);      i:=i+2;  end;
           $DB: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='DB '+inttohex(memory[i+1],2); StringGridAss.Cells[2,a]:= 'IN '+inttohex(memory[i+1],2);       i:=i+1; end;
           $DC: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='DC '+inttohex(memory[i+1],2)+' '+inttohex(memory[i+2],2); StringGridAss.Cells[2,a]:= 'CC '; StringGridAss.Cells[3,a]:=inttohex(memory[i+2],2)+inttohex(memory[i+1],2);      i:=i+2;  end;
           $DD: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='DD '+inttohex(memory[i+1],2)+' '+inttohex(memory[i+2],2); StringGridAss.Cells[2,a]:= '_call_ '; StringGridAss.Cells[3,a]:=inttohex(memory[i+2],2)+inttohex(memory[i+1],2);      i:=i+2;  end;
           $ED: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='ED '+inttohex(memory[i+1],2)+' '+inttohex(memory[i+2],2); StringGridAss.Cells[2,a]:= '_call_ '; StringGridAss.Cells[3,a]:=inttohex(memory[i+2],2)+inttohex(memory[i+1],2);      i:=i+2;  end;
           $FD: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='FD '+inttohex(memory[i+1],2)+' '+inttohex(memory[i+2],2); StringGridAss.Cells[2,a]:= '_call_ '; StringGridAss.Cells[3,a]:=inttohex(memory[i+2],2)+inttohex(memory[i+1],2);      i:=i+2;  end;
           $DE: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='DE '+inttohex(memory[i+1],2); StringGridAss.Cells[2,a]:= 'SBI ,'+inttohex(memory[i+1],2);      i:=i+1;   end;
           $DF: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='DF '; StringGridAss.Cells[2,a]:='RST 3'; end;
           $E0: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='E0 '; StringGridAss.Cells[2,a]:='RPO'; end;
           $E1: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='E1 '; StringGridAss.Cells[2,a]:='POP H'; end;
           $E2: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='E2 '+inttohex(memory[i+1],2)+' '+inttohex(memory[i+2],2); StringGridAss.Cells[2,a]:= 'JPO '; StringGridAss.Cells[3,a]:=inttohex(memory[i+2],2)+inttohex(memory[i+1],2);      i:=i+2;  end;
           $E3: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='E3 '; StringGridAss.Cells[2,a]:='XTHL'; end;
           $E4: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='E4 '+inttohex(memory[i+1],2)+' '+inttohex(memory[i+2],2); StringGridAss.Cells[2,a]:= 'CPO '; StringGridAss.Cells[3,a]:=inttohex(memory[i+2],2)+inttohex(memory[i+1],2);      i:=i+2;  end;
           $E5: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='E5 '; StringGridAss.Cells[2,a]:='PUSH H'; end;
           $E6: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='E6 '; StringGridAss.Cells[2,a]:='ANI ,'+inttohex(memory[i+1],2);      i:=i+1;   end;
           $E7: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='E7 '; StringGridAss.Cells[2,a]:='RST 4'; end;
           $E8: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='E8 '; StringGridAss.Cells[2,a]:='RPE'; end;
           $E9: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='E9 '; StringGridAss.Cells[2,a]:='PCHL'; end;
           $EA: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='EA '+inttohex(memory[i+1],2)+' '+inttohex(memory[i+2],2); StringGridAss.Cells[2,a]:= 'JPE '; StringGridAss.Cells[3,a]:=inttohex(memory[i+2],2)+inttohex(memory[i+1],2);      i:=i+2;  end;
           $EB: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='EB '; StringGridAss.Cells[2,a]:='XCHG'; end;
           $EC: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='EC '+inttohex(memory[i+1],2)+' '+inttohex(memory[i+2],2); StringGridAss.Cells[2,a]:= 'CPE '; StringGridAss.Cells[3,a]:=inttohex(memory[i+2],2)+inttohex(memory[i+1],2);      i:=i+2;  end;
           $EE: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='EE '; StringGridAss.Cells[2,a]:='XRI ,'+inttohex(memory[i+1],2);      i:=i+1;   end;
           $EF: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='EF '; StringGridAss.Cells[2,a]:='RST 5'; end;
           $F0: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='F0 '; StringGridAss.Cells[2,a]:='RP'; end;
           $F1: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='F1 '; StringGridAss.Cells[2,a]:='POP PSW'; end;
           $F2: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='F2 '+inttohex(memory[i+1],2)+' '+inttohex(memory[i+2],2); StringGridAss.Cells[2,a]:= 'JP '; StringGridAss.Cells[3,a]:=inttohex(memory[i+2],2)+inttohex(memory[i+1],2);      i:=i+2;  end;
           $F4: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='F4 '+inttohex(memory[i+1],2)+' '+inttohex(memory[i+2],2); StringGridAss.Cells[2,a]:= 'CP '; StringGridAss.Cells[3,a]:=inttohex(memory[i+2],2)+inttohex(memory[i+1],2);      i:=i+2;  end;
           $F5: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='F5 '; StringGridAss.Cells[2,a]:='PUSH PSW'; end;
           $F6: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='F6 '+inttohex(memory[i+1],2); StringGridAss.Cells[2,a]:= 'ORI ,'+inttohex(memory[i+1],2);      i:=i+1;   end;
           $F7: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='F7 '; StringGridAss.Cells[2,a]:='RST 6'; end;
           $F8: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='F8 '; StringGridAss.Cells[2,a]:='RM'; end;
           $F9: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='F9 '; StringGridAss.Cells[2,a]:='SPHL'; end;
           $FA: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='FA '+inttohex(memory[i+1],2)+' '+inttohex(memory[i+2],2); StringGridAss.Cells[2,a]:= 'JM '; StringGridAss.Cells[3,a]:=inttohex(memory[i+2],2)+inttohex(memory[i+1],2);      i:=i+2;  end;
           $FC: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='FC '+inttohex(memory[i+1],2)+' '+inttohex(memory[i+2],2); StringGridAss.Cells[2,a]:= 'CM '; StringGridAss.Cells[3,a]:=inttohex(memory[i+2],2)+inttohex(memory[i+1],2);      i:=i+2;  end;
           $FE: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='FE '+inttohex(memory[i+1],2); StringGridAss.Cells[2,a]:= 'CPI '+inttohex(memory[i+1],2);      i:=i+1;   end;
           $FF: begin StringGridAss.Cells[0,a]:=inttohex(i,4)+':'; StringGridAss.Cells[1,a]:='FF '; StringGridAss.Cells[2,a]:='RST 7'; end;
     end;
     inc(i);
     inc(a);
     StringGridAss.RowCount:=a+1;
     GaugeMain.Progress:=a;
   end;
GaugeMain.Progress:=0;   
end;

procedure TDebuggerForm.Button5Click(Sender: TObject);
var
i: integer;
a: word;
b: byte;
begin
a:=0;
GaugeMain.MinValue:=0;
GaugeMain.MaxValue:=$FFFF;
GaugeMain.Progress:=0;
ListBox1.Items.Clear;
//ListBox1.Items.BeginUpdate;
b:=strtoint(edit1.text);
if ComboBoxPoisk.ItemIndex=0 then
   begin
     for I := 0 to $ffff do
         begin
           if memory[i]=b then
                 begin
                   inc(a);
                   ListBox1.Items.add(inttostr(i));
                     GaugeMain.Progress:=i;
                 end;
         end;
     if a<>0 then
     Label18.Caption:=':'+inttostr(a)
     else
     ShowMessage('   !!!');
   end
   else
   begin
      {$R-}
      for I := 0 to $FFFF do memory_old[i]:= unit1.memory[i];
      Label18.Caption:=':'+inttostr(i);
      {$R+}
   end;
//ListBox1.Items.EndUpdate;
end;

procedure TDebuggerForm.ComboBoxPoiskKeyPress(Sender: TObject; var Key: Char);
begin
 key:=#0;
end;

procedure TDebuggerForm.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
if not (key in hexdigit) then
 key:=#0;
end;

procedure TDebuggerForm.Edit2KeyPress(Sender: TObject; var Key: Char);
begin
if not (key in hexdigit) then
 key:=#0;
end;

procedure TDebuggerForm.Edit3KeyPress(Sender: TObject; var Key: Char);
begin
if not (key in hexdigit) then
 key:=#0;
end;

procedure TDebuggerForm.Edit4KeyPress(Sender: TObject; var Key: Char);
begin
if not (key in hexdigit) then
 key:=#0;
end;

procedure TDebuggerForm.Edit6KeyPress(Sender: TObject; var Key: Char);
begin
if not (key in hexdigit) then
 key:=#0;
end;

procedure TDebuggerForm.Edit7KeyPress(Sender: TObject; var Key: Char);
begin
if not (key in hexdigit) then
 key:=#0;
end;

procedure TDebuggerForm.FormCreate(Sender: TObject);
var
  I: word;
  j:integer;
begin
GaugeMain:= TGauge.Create(self);
with GaugeMain do begin
   Parent:= StatusBar1;
   MinValue:=0;
   MaxValue:=100;
   Progress:=0;
   Top:= 2;
   Left:= StatusBar1.Panels.Items[0].Width+3;
   Height:=StatusBar1.Height - Top;
   Width:= StatusBar1.Panels.Items[1].Width-3;
end;
GaugeMain.Visible:= True;

StringGrid1.ColWidths[0]:=40;
i:=0;
j:=0;
 while (i<$1000) do
     begin
        StringGrid1.Cells[0,i+1]:=IntToHex(j,4)+':';
        j:=j+$10;
        inc(i);
     end;
 i:=0;
 while (i<$10) do
     begin
        StringGrid1.Cells[i+1,0]:=IntToHex(i,0);
        inc(i);
     end;
StringGrid1.ColWidths[17]:=120;
end;

procedure TDebuggerForm.StringGrid1KeyPress(Sender: TObject; var Key: Char);
const
//hexdigit = '0123456789ABCDEFabcdef';
hexdigit: set of Char = ['0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F','a','b','c','d','e','f',#13];
var
i: word;
begin
if key in hexdigit then
 begin
 //if StringGrid.Selection then

  if Key = #13 then
   with StringGrid1 do
     if Col < ColCount - 1 then { !}
       Col := Col + 1
     else if Row < RowCount - 1 then
     begin { !}
       Row := Row + 1;
       Col := 1;
     end
     else
     begin { ! -   !}
       Row := 1;
       Col := 1;
       {       }
     end
 end
 else
     begin
      key:=#0;
      exit;
     end;

end;

procedure TDebuggerForm.StringGrid1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
Column, Row: Longint;
begin
StringGrid1.MouseToCell(x, y, Column, Row);
//ShowMessage(' - ' + IntToStr(row) + #13 + ' - ' + IntToStr(column)+#13+IntToHex(((row-1)*16)+column-1,2)+#13+IntToHex(unit1.memory[((row-1)*16)+column-1],2));

end;

procedure TDebuggerForm.StringGrid1MouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var
Column, Row: Longint;
begin
StringGrid1.MouseToCell(x, y, Column, Row);
if (column>0) and (column<17) and (row>0) then
     begin
         StatusBar1.Panels.Items[0].Text:='Adress:' + IntToHex(((row-1)*16)+column-1,4)+ ' Byte:'+IntToHex(unit1.memory[((row-1)*16)+column-1],2);
         {if CheckBox16_10.Checked then
            begin
               edit2.Text:=IntToHex(((row-1)*16)+column-1,4);
               edit3.Text:=IntToHex(unit1.memory[((row-1)*16)+column-1],2);
            end
            else
            begin
               edit2.Text:=inttostr(((row-1)*16)+column-1);
               edit3.Text:=inttostr(unit1.memory[((row-1)*16)+column-1]);
            end;  }
     end;
end;

procedure TDebuggerForm.StringGridAssDrawCell(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
begin
with StringGridAss.canvas do
begin
   if ACol =3 then
     begin
       font.color := clMaroon;
       font.Style := [fsBold];
       TextOut(Rect.Left + 2, Rect.Top + 2, StringGridAss.Cells[ACol, ARow]);
     end;
   if ACol =2 then
     begin
       font.color := clBlack;
       font.Style := [fsBold];
       TextOut(Rect.Left + 2, Rect.Top + 2, StringGridAss.Cells[ACol, ARow]);
     end;
   if ACol =0 then
     begin
       font.color := clNavy;
       font.Style := [fsBold];
       TextOut(Rect.Left + 2, Rect.Top + 2, StringGridAss.Cells[ACol, ARow]);
     end;
   if ACol =1 then
     begin
       font.color := clNavy;
       font.Style := [];
       TextOut(Rect.Left + 2, Rect.Top + 2, StringGridAss.Cells[ACol, ARow]);
     end;
end;

end;

function TDebuggerForm.HexToInt(CH : string): integer;
begin
result:=strtoint('$'+CH);
end;

procedure TDebuggerForm.ListBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
if ListBox1.Count<>0 then
    begin
// ShowMessage(ListBox1.Items.Strings[ListBox1.ItemIndex]);
// ShowMessage(inttostr(trunc(strtoint(ListBox1.Items.Strings[ListBox1.ItemIndex])/16)));
//ShowMessage(inttostr(strtoint(ListBox1.Items.Strings[ListBox1.ItemIndex]) mod 16));
// SetCaretPosition(StringGrid1,(strtoint(ListBox1.Items.Strings[ListBox1.ItemIndex]) mod 16)+1,trunc(strtoint(ListBox1.Items.Strings[ListBox1.ItemIndex])/16)+1,1);
     StringGrid1.Col := (strtoint(ListBox1.Items.Strings[ListBox1.ItemIndex]) mod 16)+1;
     StringGrid1.Row := trunc(strtoint(ListBox1.Items.Strings[ListBox1.ItemIndex])/16)+1;
     StringGrid1.SetFocus;
    end;
end;

procedure TDebuggerForm.ListBox2MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
if ListBox2.Count<>0 then
    begin
     StringGrid1.Col := (strtoint(ListBox2.Items.Strings[ListBox2.ItemIndex]) mod 16)+1;
     StringGrid1.Row := trunc(strtoint(ListBox2.Items.Strings[ListBox2.ItemIndex])/16)+1;
     StringGrid1.SetFocus;
    end;
end;

procedure TDebuggerForm.ListBox3MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
if ListBox3.Count<>0 then
    begin
     StringGrid1.Col := (strtoint(ListBox3.Items.Strings[ListBox3.ItemIndex]) mod 16)+1;
     StringGrid1.Row := trunc(strtoint(ListBox3.Items.Strings[ListBox3.ItemIndex])/16)+1;
     StringGrid1.SetFocus;
    end;
end;

end.
