use32		   ;  32-  
org    0x0	   ;   
db     'MENUET01'  ; 8-  MenuetOS
dd     0x01	   ;   ( 1)
dd     START	   ;   
dd     I_END	   ;  
dd 1700000;1693100;1700000;1677721;2097152;0x200000;0x1000000	    ;  
dd 1700000;1693100;1677721;2097152;0x200000;0x1000000	    ;   
dd     0x0	   ;    
dd     0x0	   ; 
	include 'uLVComp.asm'
	include 'uKeyBoard.asm'
	include 'uMem.asm'
	include 'uDrawScreen.asm'
	include 'ui8080.asm'
	include 'MACROS.INC'
  include 'Main2.asm'
  include 'scancodeLV.asm'
;---------------------------------------------------------------------
EmulEngineTimer0: ;    
       mov eax,[opcodes_to_run]
       mov [i8080_do_opcodes_nb_cycles],eax
       call i8080_do_opcodes
      call draw_screen
	    ret

EmulEngineTimer1:
;  KOS 2 ;
; Extr_KlbrInWin.bat ! 2 
;QEMU -  
      Call EmulEngineTimer0
      call Timer1
	ret

EmulEngineTimer2:
;  KOS 2    ;
; Extr_KlbrInWin.bat    3 
; QEMU - 

Call Timer2
mov eax,[Timer2_result]
Cmp eax, [PlatoonTimer2T]
jb EmulEngineTimer2_ret
call PlatoonTimer2 ;  
      Call EmulEngineTimer0
EmulEngineTimer2_ret:
ret

EmulEngineTimer3:
; ;  KOS 1 ;
;Extr_KlbrInWin.bat 1 
;QEMU -  
      Call EmulEngineTimer0
      call Timer3
	ret


START:
Call INITmain ;  
;mov [rgPC],$0000c000 ; rgPC:=$C000;
CycleProgram: ;   :
call CycleProcesEvents ;    
cmp [fPause],0
jnz CycleProgram_m1; 
 
;_case_TimerNumber_of:
  mov eax,[TimerNumber]
 Call dword [eax*4+TimerAdrs]
 
CycleProgram_m2:
;mov dword [@FLagExit],1  ;      
cmp byte [@FLagExit],0
jz CycleProgram ;
   mov EAX, -1		  ;   
jmp CycleProgram

; 
CycleProgram_m1:
;  
inc dword [CountPause]
cmp [CountPause],50;25  
    Jnz p_m1 
 call draw_screen
 mov [CountPause],0    
p_m1:
 ;  
 add [ColorPause],1234567
 and [ColorPause],$FFFFFF
    mov  ebx,[WindowSizeX]
    shr ebx,1
    shl ebx,16
    mov  eax,[WindowSizeY]
    shr eax,1
    add  ebx,eax ;15*65536+10
    mov ecx, [ColorPause] 
    mov  edx, textPause
    mov  esi, 8
    mov  eax, 4 
    mcall
    call Timer3
jmp CycleProgram_m2;
textPause db 'Pause...',0

I_END:				   ;   
ColorPause dd 0
CountPause dd 0
;!!!!!!!!    
VideoDirtyM rb 16385
ImageData rd (256*3 * 256 * 2) ;      
 kbd_baseM rb 9; //   
 kbd_extM rb 5;//=(1,2,3,4,5);
;;{ i8080_do_opcodes }
tmp3 rd 1
tmp2 rd 1
tmp1 rd 1
opcode rd 1
clock rd 1
i8080_do_opcodes_nb_cycles  rd 1
m28m_Result rd 1
m29m_Result rd 1
m30m_Result rd 1
m36m_a rd 1
m37m_a rd 1
m38m_Result rd 1
m39m_Result rd 1
m40m_a rd 1
m41m_a rd 1
m42m_a rd 1
m43m_a rd 1
m44m_a rd 1
m46m_Result rd 1
m53m_Result rd 1
m54m_Result rd 1
m55m_Result rd 1
m57m_Result rd 1
m58m_Result rd 1
m59m_Result rd 1
m60m_Result rd 1
m61m_a rd 1
m62m_a rd 1
m63m_a rd 1
m64m_a rd 1
m67m_a rd 1
mD7m_a rd 1
m70m_a rd 1
m73m_a rd 1
m71m_a rd 1
m79m_Result rd 1
m84m_a rd 1
m85m_a rd 1
m86m_a rd 1
m87m_a rd 1
m88m_a rd 1
m89m_a rd 1
m90m_a rd 1
m91m_a rd 1
m92m_a rd 1
mA1m_Result rd 1
mA5m_a rd 1
mA6m_a rd 1
mB4m_a1 rd 1
mB4m_a2 rd 1
mB6m_a rd 1
mB7m_a rd 1
mB8m_Result rd 1
mB9m_Result rd 1

 adrs rd 256 ;=  Case of opcode
 TableGraphicsMode rd 3 ;
 TableDrawScreenPR rd 3
 TableKeyDop rd 256
 TableKeyOsnEngl rd 256
 TableKeyOsnRus  rd 256
 TableMy_col2 rd 4
 TableSupCol2 rd 5
 WindowSizeX rd 1 ;  
 WindowSizeY rd 1  ;  